package com.jeffhanson.resources;

import com.jeffhanson.services.Service;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;

/**
 * User: jhanson
 * Date: Jun 11, 2008
 * Time: 4:29:19 PM
 */
public class ResourceAdapter
{
  /* todo - add logic to configure instance from dynamic data */
  private static ResourceAdapter instance = new ResourceAdapter();

  public static ResourceAdapter getInstance()
  {
    return instance;
  }

  public Resource readResource(String resourcePath, ServletContext servletContext)
    throws ResourceException
  {
    return ResourceCache.read(resourcePath, servletContext);
  }

  public void createResource(String resourcePath, ServletContext servletContext, HttpServletRequest request)
    throws ResourceException
  {
    ResourceCache.create(resourcePath, servletContext, request);
  }

  public void updateResource(String resourcePath, ServletContext servletContext, HttpServletRequest request)
    throws ResourceException
  {
    ResourceCache.update(resourcePath, servletContext, request);
  }

  public void deleteResource(String resourcePath, ServletContext servletContext)
    throws ResourceException
  {
    ResourceCache.delete(resourcePath, servletContext);
  }

  public long getResourceLastModified(String resourcePath, ServletContext servletContext)
    throws ResourceException
  {
    return ResourceCache.getLastModified(resourcePath, servletContext);
  }
}
