package com.jeffhanson;

import com.jeffhanson.kernel.KernelException;
import com.jeffhanson.kernel.Kernel;
import com.jeffhanson.kernel.Daemon;

import java.util.Properties;

/**
 * User: jhanson
 * Date: Jul 13, 2008
 * Time: 2:23:24 PM
 */
public class TestMain
{
  public static void main(String[] args)
  {
    try
    {
      Daemon daemon = new Daemon();
      
      daemon.initialize();
      daemon.startDaemon();

      boolean invoked = false;
      final long startTime = System.currentTimeMillis();
      long currTime = startTime;
      while ((currTime - startTime) < 20000)
      {
        currTime = System.currentTimeMillis();
        try
        {
          Thread.sleep(3000);
        }
        catch (InterruptedException e)
        {
          // ignore
        }

        if (!invoked)
        {
          String[] serviceNames = daemon.getKernel().getInstalledServiceNames();
          if (null != serviceNames && serviceNames.length > 0)
          {
            for (int i = 0; i < serviceNames.length; i++)
            {
              String serviceName = serviceNames[i];
              if (serviceName.equalsIgnoreCase("com.jeffhanson.service.bundles.dictionary"))
              {
                System.out.println("Found installed service: " + serviceName);
                Object service = daemon.getKernel().getServiceByName(serviceName);
                try
                {
                  invokeDictionaryService(daemon.getKernel(), service);
                  invoked = true;
                }
                catch (KernelException e)
                {
                  e.printStackTrace();
                }
              }
            }
          }
        }
      }

      daemon.stopDaemon();
    }
    catch (KernelException e)
    {
      e.printStackTrace();
    }
  }

  public static void invokeDictionaryService(Kernel kernel, Object service)
    throws KernelException
  {
    Properties props = new Properties();
    props.put("1", "welcome");
    System.out.println("Service invocation returned: " + kernel.invokeService(service, props));

    props.clear();

    props.put("2", "rigma");
    System.out.println("Service invocation returned: " + kernel.invokeService(service, props));
  }
}
