package com.jeffhanson.kernel;

import java.util.Properties;
import java.io.File;

/**
 * User: jhanson
 * Date: Jul 14, 2008
 * Time: 11:50:34 PM
 */
public interface Kernel
{
  public void setServicesLocation(File serviceLocation);

  public File getServicesLocation();

  String[] getInstalledServiceNames();

  Object[] getInstalledServices();

  Object getServiceByName(String serviceName);

  void initialize()
    throws KernelException;

  void start()
    throws KernelException;

  void stop()
      throws KernelException;

  Object installService(String serviceLocation)
        throws KernelException;

  void uninstallService(String serviceLocation)
          throws KernelException;

  Object invokeService(Object service, Properties props)
            throws KernelException;
}
