package com.jeffhanson.kernel;

import java.io.File;

/**
 * User: jhanson
 * Date: Jul 14, 2008
 * Time: 11:52:25 PM
 */
public class KernelFactory
{
  public static Kernel newKernel(File servicesLocationDir)
    throws KernelException
  {
    String kernelClsName = System.getProperty("com.jeffhanson.kernel");
    if (null == kernelClsName || kernelClsName.length() <= 0)
    {
      throw new KernelException("Kernel system property is not set");
    }
    
    try
    {
      Class cls = Class.forName(kernelClsName);
      if (com.jeffhanson.kernel.Kernel.class.isAssignableFrom(cls))
      {
        Object obj = cls.newInstance();
        Kernel kernel = (Kernel)obj;
        kernel.setServicesLocation(servicesLocationDir);
        kernel.initialize();
        return kernel;
      }
      else
      {
        throw new KernelException("Kernel system property is not derived from the Kernel class");
      }
    }
    catch (Exception e)
    {
      throw new KernelException(e);
    }
  }
}
