package com.jeffhanson.kernel;

import java.util.EventObject;

/**
 * User: jhanson
 * Date: Jul 14, 2008
 * Time: 8:25:50 PM
 */
public class ServicePollerEvent extends EventObject
{
  private String m_serviceLocation = "";

  /**
   * Constructs a prototypical Event.
   *
   * @param source The object on which the Event initially occurred.
   * @throws IllegalArgumentException if source is null.
   */
  public ServicePollerEvent(Object source, String serviceLocation)
  {
    super(source);

    m_serviceLocation = serviceLocation;
  }

  /**
   * Retrieves the location for the service in question
   *
   * @return the location of the service
   */
  public String getServiceLocation()
  {
    return m_serviceLocation;
  }
}
