package com.jeffhanson.service;

import java.util.Properties;

/**
 * This interface defines the <tt>SimpleService</tt> service. This service
 * is used for generic service functionality. It has one service properties:
 * <ul>
 *   <li>simple.service.name - A <tt>String</tt> name for the service.
 *   </li>
 * </ul>
**/
public interface SimpleService
{
    /**
     * A property for the name of the service.
    **/
    public static final String NAME_PROPERTY = "simple.service.name";

    /**
     * Method to execute the service.
     * @param props Any properties needed for execution.
    **/
    public Object execute(Properties props);
}
