package com.jeffhanson.governance;

/**
 * User: jhanson
 * Date: Aug 9, 2008
 * Time: 4:43:49 PM
 */
public class GovernanceEngineFactory
{
  public static GovernanceEngine newInstance()
    throws GovernanceEngineFactoryException
  {
    try
    {
      String clsName = System.getProperty("com.jeffhanson.governance.engine");
      if (null == clsName || clsName.length() <= 0)
      {
        clsName = SimpleGovernanceEngine.class.getName();
      }
      Class cls = Class.forName(clsName);
      if (com.jeffhanson.governance.GovernanceEngine.class.isAssignableFrom(cls))
      {
        Object obj = cls.newInstance();
        GovernanceEngine governanceEngine = (GovernanceEngine)obj;
        governanceEngine.initialize();
        return governanceEngine;
      }
      else
      {
        throw new GovernanceEngineFactoryException("Governance engine class is not derived from the GovernanceEngine class");
      }
    }
    catch (Exception e)
    {
      throw new GovernanceEngineFactoryException(e);
    }
  }
}
