package com.jeffhanson.governance.privacy;

import com.jeffhanson.mediation.Message;

/**
 * User: jhanson
 * Date: Aug 9, 2008
 * Time: 4:30:00 PM
 */
public class PrivacyModuleFactory
{
  public static PrivacyModule getPrivacyModule(Message message)
    throws PrivacyModuleFactoryException
  {
    try
    {
      Class cls = classForMessageType(message);
      if (com.jeffhanson.governance.privacy.PrivacyModule.class.isAssignableFrom(cls))
      {
        Object obj = cls.newInstance();
        PrivacyModule privacyModule = (PrivacyModule)obj;
        privacyModule.initialize();
        return privacyModule;
      }
      else
      {
        throw new PrivacyModuleFactoryException("Privacy module class is not derived from the PrivacyModule class");
      }
    }
    catch (Exception e)
    {
      throw new PrivacyModuleFactoryException(e);
    }
  }

  private static Class classForMessageType(Message message)
    throws PrivacyModuleFactoryException
  {
    String contentType = message.getContentType();

    // enable privacy constraints based on content type and message attributes
    return SimplePrivacyModule.class;
  }
}
