package com.jeffhanson.mediation;

import com.jeffhanson.mediation.auditing.AuditModule;
import com.jeffhanson.mediation.logging.LoggingModule;
import com.jeffhanson.governance.security.SecurityModule;
import com.jeffhanson.governance.GovernanceEngine;
import com.jeffhanson.mediation.transform.TransformModule;

/**
 * User: jhanson
 * Date: Aug 1, 2008
 * Time: 9:46:24 PM
 */
public interface Mediator
{
  void initialize();

  void mediate(Message message)
    throws MediationException;

  void setAuditModule(AuditModule auditModule);

  void setLoggingModule(LoggingModule loggingModule);

  void setGovernanceEngine(GovernanceEngine governanceEngine);

  void setTransformModule(TransformModule transformModule);
}
