package com.jeffhanson.mediation;

/**
 * User: jhanson
 * Date: Aug 1, 2008
 * Time: 9:43:18 PM
 */
public class MediatorFactory
{
  public static Mediator newMediator()
    throws MediatorFactoryException
  {
    String mediatorClsName = System.getProperty("com.jeffhanson.mediator");
    if (null == mediatorClsName || mediatorClsName.length() <= 0)
    {
      throw new MediatorFactoryException("Mediator system property is not set");
    }

    try
    {
      Class cls = Class.forName(mediatorClsName);
      if (com.jeffhanson.mediation.Mediator.class.isAssignableFrom(cls))
      {
        Object obj = cls.newInstance();
        Mediator mediator = (Mediator)obj;
        mediator.initialize();
        return mediator;
      }
      else
      {
        throw new MediatorFactoryException("Mediator system property is not derived from the Mediator class");
      }
    }
    catch (Exception e)
    {
      throw new MediatorFactoryException(e);
    }
  }
}
