package com.jeffhanson.mediation;

import junit.framework.Test;
import junit.framework.TestSuite;
import junit.framework.TestCase;
import com.jeffhanson.mediation.auditing.SimpleAuditModule;
import com.jeffhanson.mediation.logging.SimpleLoggingModule;

/**
 * SimpleMessage Tester.
 *
 * @author <Authors name>
 * @version 1.0
 * @since <pre>08/01/2008</pre>
 */
public class SimpleMessageTest
  extends TestCase
{
  public static final String RDF_CONTENT = "<rdf:RDF\n" +
                                           "  xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n" +
                                           "  xmlns:em=\"http://www.example.org/email#\">\n" +
                                           "\n" +
                                           "<rdf:Description\n" +
                                           "  rdf:about=\"http://www.example.org/contacts/John%20Doe\">\n" +
                                           "  <em:email>jdoe@example.org</em:email>\n" +
                                           "</rdf:Description>\n" +
                                           "\n" +
                                           "<rdf:Description\n" +
                                           "  rdf:about=\"http://www.example.org/contacts/Bill%20Smith\">\n" +
                                           "  <em:email>bsmith@example.org</em:email>\n" +
                                           "</rdf:Description>\n" +
                                           "</rdf:RDF>";
  
  public SimpleMessageTest(String name)
  {
    super(name);
  }

  public void setUp()
    throws Exception
  {
    super.setUp();
  }

  public void tearDown()
    throws Exception
  {
    super.tearDown();
  }

  public void testMediation()
    throws Exception
  {
    Message message = new SimpleMessage("application/rdf+xml");
    message.setContent(RDF_CONTENT);

    try
    {
      System.setProperty("com.jeffhanson.audit.module", SimpleAuditModule.class.getName());
      System.setProperty("com.jeffhanson.logging.module", SimpleLoggingModule.class.getName());
      System.setProperty("com.jeffhanson.mediator", SimpleMediator.class.getName());
      Mediator mediator = MediatorFactory.newMediator();
      mediator.mediate(message);
      System.out.println("\nMediated message:\n" + message.getContent());
    }
    catch (Throwable t)
    {
      t.printStackTrace();
      throw new Exception(t);
    }
  }

  public static Test suite()
  {
    return new TestSuite(SimpleMessageTest.class);
  }
}
