package com.jeffhanson.monitoring;

import java.util.EventObject;
import java.util.Date;

/**
 * User: jhanson
 * Date: Aug 3, 2008
 * Time: 9:19:46 PM
 */
public class EventSourceEvent extends EventObject
{
  private Date timeStamp = null;
  private String type = "";
  private String content = "";

  /**
   * Constructs an event source event.
   *
   * @param source The object on which the Event initially occurred.
   * @param timeStamp The timestamp of the event.
   * @param type The type of the event.
   * @param content The content of the event.
   */
  public EventSourceEvent(Object source, Date timeStamp, String type, String content)
  {
    super(source);

    this.timeStamp = timeStamp;
    this.type = type;
    this.content = content;
  }

  public Date getTimeStamp()
  {
    return timeStamp;
  }

  public String getType()
  {
    return type;
  }

  public String getContent()
  {
    return content;
  }
}
