package com.jeffhanson.monitoring;

import java.util.EventObject;
import java.util.Date;

/**
 * User: jhanson
 * Date: Aug 3, 2008
 * Time: 7:59:11 PM
 */
public class ProtocolAdapterEvent extends EventObject
{
  private String type = "";
  private String content = "";
  private Date timeStamp = null;

  /**
   * Constructs a protocol adapter event object.
   *
   * @param source The object on which the Event initially occurred.
   * @param type The type of event.
   * @param content The content of the event.
   */
  public ProtocolAdapterEvent(Object source, Date timeStamp, String type, String content)
  {
    super(source);

    this.timeStamp = timeStamp;
    this.type = type;
    this.content = content;
  }

  public Date getTimeStamp()
  {
    return timeStamp;
  }

  public String getType()
  {
    return type;
  }

  public String getContent()
  {
    return content;
  }
}
