package com.jeffhanson.mashups.timeseries;

import java.util.Date;

/**
 * User: jhanson
 * Date: Aug 24, 2008
 * Time: 8:01:09 PM
 */
public class TestMain
{
  private double lastValue = 100.0;

  public static void main(String[] args)
  {
    TestMain app = new TestMain();
    app.runTests();
  }

  private void runTests()
  {
    final TimeSeries timeSeries = new TimeSeries("Test Series");
    timeSeries.addTimeSeriesChangeListener(new TimeSeriesChangeListener()
    {
      public void intervalAdded(TimeSeriesChangedEvent event)
      {
        System.out.println("Interval added to " + ((TimeSeries)event.getSource()).getName() + ": "
                           + event.getInterval().getPeriod().getTimestamp() + " = " + event.getInterval().getValue());
      }
    });

    new Thread(new Runnable()
    {
      public void run()
      {
        long startTime = System.currentTimeMillis();
        long currTime = startTime;
        while ((currTime - startTime) < 20000)
        {
          final double factor = 0.90 + 0.2 * Math.random();
          lastValue = lastValue * factor;
          final Date timestamp = new Date();
          final TimePeriod timePeriod = new TimePeriod()
          {
            public Date getTimestamp()
            {
              return timestamp;
            }
          };

          timeSeries.addInterval(timePeriod, lastValue);
          
          try
          {
            Thread.sleep(500);
          }
          catch (InterruptedException e)
          {
            e.printStackTrace();
          }
          
          currTime = System.currentTimeMillis();
        }
      }
    }).start();
  }
}
