package com.jeffhanson.mashups.json;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * User: jhanson
 * Date: Sep 22, 2008
 * Time: 10:02:32 AM
 */
public class FrontController extends HttpServlet
{
  private static final String JSON_COMMENTED =
    "/*" +
    "[" +
    "  {" +
    "    \"name\": \"object 1\"," +
    "    \"message\": \"Hello from object 1\"" +
    "  }," +
    "  {" +
    "    \"name\": \"object 2\"," +
    "    \"message\": \"Hello from object 2\"" +
    "  }," +
    "  {" +
    "    \"name\": \"object 3\"," +
    "    \"message\": \"Hello from object 3\"" +
    "  }," +
    "  {" +
    "    \"name\": \"object 4\"," +
    "    \"message\": \"Hello from object 4\"" +
    "  }," +
    "  {" +
    "    \"name\": \"object 5\"," +
    "    \"message\": \"Hello from object 5\"" +
    "  }," +
    "  {" +
    "    \"name\": \"object 6\"," +
    "    \"message\": \"Hello from object 6\"" +
    "  }" +
    "]" +
    "*/";

  private static final String JSON_EMBEDDED_FUNCS =
    "[" +
    "  {" +
    "    name: \"object 1\"," +
    "    message: \"Hello from object 1\"," +
    "    evil: alert(\"You should not see this!\")" +
    "  }," +
    "  {" +
    "    name: \"object 2\"," +
    "    message: \"Hello from object 2\"" +
    "  }," +
    "  {" +
    "    name: \"object 3\"," +
    "    message: \"Hello from object 3\"" +
    "  }," +
    "  {" +
    "    name: \"object 4\"," +
    "    message: \"Hello from object 4\"" +
    "  }," +
    "  {" +
    "    name: \"object 5\"," +
    "    message: \"Hello from object 5\"" +
    "  }," +
    "  {" +
    "    name: \"object 6\"," +
    "    message: \"Hello from object 6\"" +
    "  }" +
    "]";

  protected void doGet(HttpServletRequest req,
                       HttpServletResponse res)
    throws ServletException, IOException
  {
    String messageResult = "{\"result\": \"failed\"}";
    
    String resource = req.getPathInfo();
    if (null != resource && resource.equalsIgnoreCase("/commented"))
    {
      messageResult = JSON_COMMENTED;
    }
    else if (null != resource && resource.equalsIgnoreCase("/embeddedfuncs"))
    {
      messageResult = JSON_EMBEDDED_FUNCS;
    }

    res.setContentType("application/json");
    PrintWriter out = res.getWriter();
    out.println(messageResult);
  }

  protected void doPost(HttpServletRequest req,
                        HttpServletResponse res)
    throws ServletException, IOException
  {
    res.setContentType("application/json");
    PrintWriter out = res.getWriter();
    out.println("{\"result\": \"success\"}");
  }

  protected void doPut(HttpServletRequest req,
                       HttpServletResponse res)
    throws ServletException, IOException
  {
    res.setContentType("application/json");
    PrintWriter out = res.getWriter();
    out.println("{\"result\": \"success\"}");
  }

  protected void doDelete(HttpServletRequest req,
                          HttpServletResponse res)
    throws ServletException, IOException
  {
    res.setContentType("application/json");
    PrintWriter out = res.getWriter();
    out.println("{\"result\": \"success\"}");
  }
}
