<html>
<head>
<title>Test for secure JSON</title>

  <script type="text/javascript" src="js/json2.js"></script>
  <script type="text/javascript" src="js/ajax.js"></script>

<script type="text/javascript">

//<![CDATA[

//===================================================
// removes comments wrapped around a JSON object
//===================================================
function removeComments(jsonStr)
{
  return jsonStr.replace(/\/\*|\*\//g, "");
}

//===================================================
// test callback
//===================================================
function testResultHandler(responseText)
{
  if (responseText)
  {
    alert("Raw results = " + responseText);

    var jsonTxt = removeComments(responseText);

    alert("Sanitized results = " + jsonTxt);

    try
    {
      // Use JSON.parse instead of eval(jsonTxt) to, among other things,
      // eliminate risk of executing embedded functions
      var jsonObj = JSON.parse(jsonTxt);
      for (var i in jsonObj)
      {
        alert("JSON obj " + i + " = " + JSON.stringify(jsonObj[i]));
      }
    }
    catch (e)
    {
      alert("Embedded functions caused JSON.parse to throw an exception");
    }
  }
  else
  {
    alert("testResultHandler responseText is null");
  }
}

//]]>

</script>
</head>

<body>
<form method="GET"
      action="javascript:ajaxSyncRequest('http://localhost:8080/securejson/data/commented', 'GET', 'rigma', testResultHandler)"
      name="getCommentedDataForm">
  <input type="submit" value="Get Commented JSON Data" name="submit"/>
</form>

<p/>

<form method="GET"
      action="javascript:ajaxSyncRequest('http://localhost:8080/securejson/data/embeddedfuncs', 'GET', 'rigma', testResultHandler)"
      name="getEmbeddedFuncsDataForm">
  <input type="submit" value="Get JSON Data with Embedded Functions" name="submit"/>
</form>

</body>
</html>
