package com.jeffhanson.mashups.web;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.ServletException;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;

/**
 * User: jhanson
 * Date: Sep 22, 2008
 * Time: 8:04:03 PM
 */
public class FrontController extends HttpServlet
{
  protected void doGet(HttpServletRequest req,
                       HttpServletResponse res)
    throws ServletException, IOException
  {
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    out.println("<h3>GET processed successfully</h3>");
  }

  protected void doPost(HttpServletRequest req,
                        HttpServletResponse res)
    throws ServletException, IOException
  {
    Validator validator = ValidatorFactory.getValidator(ValidatorFactory.CONTACTS_VALIDATOR);

    res.setContentType("text/html");
    PrintWriter out = res.getWriter();

    Iterator<String> iter = validator.fieldNames();
    while (iter.hasNext())
    {
      String fieldName = iter.next();
      String fieldValue = req.getParameter(fieldName);
      if ((null == fieldValue) || fieldValue.length() <= 0)
      {
        out.println("<h3>" + fieldName + " not found. Press back button.</h3>");
      }
      else if (!validator.validate(fieldName, fieldValue))
      {
        out.println("<h3>" + fieldName + " is invalid. Press back button.</h3>");
      }
    }

    out.println("<h3>POST data validated successfully</h3>");
  }

  protected void doPut(HttpServletRequest req,
                       HttpServletResponse res)
    throws ServletException, IOException
  {
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    out.println("<h3>PUT processed successfully</h3>");
  }

  protected void doDelete(HttpServletRequest req,
                          HttpServletResponse res)
    throws ServletException, IOException
  {
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    out.println("<h3>DELETE processed successfully</h3>");
  }
}
