<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
        "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
  <title>Validation test</title>
  <script type="text/javascript">
  //<![CDATA[

  function validateName(val)
  {
    var valRegExp  = /^([a-z A-Z]+)$/;
    return valRegExp.test(val);
  }

  function validateAddress(val)
  {
    var valRegExp  = /^([a-z A-Z1-9]+)$/;
    return valRegExp.test(val);
  }

  function validateCity(val)
  {
    var valRegExp  = /^([a-z A-Z]+)$/;
    return valRegExp.test(val);
  }

  function validateZip(val)
  {
    var valRegExp  = /(^\d{5}$)|(^\d{5}-\d{4}$)/;
    return valRegExp.test(val);
  }

  function validatePhone(val)
  {
    var valRegExp  = /^\([1-9]\d{2}\)\s?\d{3}\-\d{4}$/;
    return valRegExp.test(val);
  }

  function validateEmail(val)
  {
    var valRegExp  =
      /(^[a-z]([a-z_\.]*)@([a-z_\.]*)([.][a-z]{3})$)|(^[a-z]([a-z_\.]*)@([a-z_\.]*)(\.[a-z]{3})(\.[a-z]{2})*$)/;
    return valRegExp.test(val);
  }

  function validateFormInput(form)
  {
    if (form.contact_name.value == "")
    {
      alert("Please enter your name.");
      form.contact_name.focus();
      return false ;
    }
    if (!validateName(form.contact_name.value))
    {
      alert("Name contains invalid characters.");
      form.contact_name.focus();
      return false ;
    }

    if (form.contact_address.value == "")
    {
      alert("Please enter your address.");
      form.contact_address.focus();
      return false ;
    }
    if (!validateAddress(form.contact_address.value))
    {
      alert("Address contains invalid characters.");
      form.contact_address.focus();
      return false ;
    }

    if (form.contact_city.value == "")
    {
      alert("Please enter your city.");
      form.contact_city.focus();
      return false ;
    }
    if (!validateCity(form.contact_city.value))
    {
      alert("City contains invalid characters.");
      form.contact_city.focus();
      return false ;
    }

    if (form.contact_zip.value == "")
    {
      alert("Please enter your zip.");
      form.contact_zip.focus();
      return false ;
    }
    if (!validateZip(form.contact_zip.value))
    {
      alert("Zip code must be in the form of nnnnn or nnnnn-nnnn.");
      form.contact_phone.focus();
      return false ;
    }

    if (form.contact_phone.value == "")
    {
      alert("Please enter your phone.");
      form.contact_phone.focus();
      return false ;
    }
    if (!validatePhone(form.contact_phone.value))
    {
      alert("Phone number must be in the form of (nnn) nnn-nnnn or (nnn)nnn-nnnn.");
      form.contact_phone.focus();
      return false ;
    }

    if (form.contact_email.value == "")
    {
      alert("Please enter your email address.");
      form.contact_email.focus();
      return false ;
    }
    if (!validateEmail(form.contact_email.value))
    {
      alert("Email address must be in the form of cccccccc@ccc.com, cccccccc@ccc.org, etc.");
      form.contact_email.focus();
      return false ;
    }
    
    // form.action.value = "process.cgi";

    return true ;
  }

  //]]>
  </script>
</head>
<body>

<table border="1">
  <form method="POST"
      action="http://localhost:8080/validate/v/test"
      onsubmit="return validateFormInput(this);"
      name="ValidateInputTestForm">
    <tr><td>Name:</td><td colspan="5"><input type="text" name="contact_name" size="100" maxlength="40"/></td></tr>
    <tr><td>Address:</td><td colspan="5"><input type="text" name="contact_address" size="100" maxlength="40"/></td></tr>
    <tr><td>City:</td><td><input type="text" name="contact_city" size="44" maxlength="20"/></td>
    <td>State:</td>
      <td>
        <select name="contact_state">
          <option value="AL">AL</option>
          <option value="AK">AK</option>
          <option value="AZ">AZ</option>
          <option value="AR">AR</option>
          <option value="CA">CA</option>
          <option value="CO">CO</option>
          <option value="CT">CT</option>
          <option value="DE">DE</option>
          <option value="DC">DC</option>
          <option value="FL">FL</option>
          <option value="GA">GA</option>
          <option value="HI">HI</option>
          <option value="ID">ID</option>
          <option value="IL">IL</option>
          <option value="IN">IN</option>
          <option value="IA">IA</option>
          <option value="KS">KS</option>
          <option value="KY">KY</option>
          <option value="LA">LA</option>
          <option value="ME">ME</option>
          <option value="MD">MD</option>
          <option value="MA">MA</option>
          <option value="MI">MI</option>
          <option value="MN">MN</option>
          <option value="MS">MS</option>
          <option value="MO">MO</option>
          <option value="MT">MT</option>
          <option value="NE">NE</option>
          <option value="NV">NV</option>
          <option value="NH">NH</option>
          <option value="NJ">NJ</option>
          <option value="NM">NM</option>
          <option value="NY">NY</option>
          <option value="NC">NC</option>
          <option value="ND">ND</option>
          <option value="OH">OH</option>
          <option value="OK">OK</option>
          <option value="OR">OR</option>
          <option value="PA">PA</option>
          <option value="RI">RI</option>
          <option value="SC">SC</option>
          <option value="SD">SD</option>
          <option value="TN">TN</option>
          <option value="TX">TX</option>
          <option value="UT">UT</option>
          <option value="VT">VT</option>
          <option value="VA">VA</option>
          <option value="WA">WA</option>
          <option value="WV">WV</option>
          <option value="WI">WI</option>
          <option value="WY">WY</option>
        </select>
      </td>
    <td>Zip:</td><td><input type="text" name="contact_zip" size="24" maxlength="10"/></td></tr>
    <tr><td>Phone:</td><td colspan="5"><input type="text" name="contact_phone" size="20" maxlength="14"/></td></tr>
    <tr><td>Email:</td><td colspan="5"><input type="text" name="contact_email" size="100" maxlength="50"/></td></tr>
    <tr><td colspan="6" align="center"><input type="submit" value="Submit" name="submit"/></td></tr>
  </form>
</table>

</body>

</html>