package org.mashups4j.governance.policies;

import org.mashups4j.mediation.Message;

/**
 * User: jhanson
 * Date: Aug 9, 2008
 * Time: 4:36:42 PM
 */
public class PolicyModuleFactory
{
  public static PolicyModule getPolicyModule(Message message)
    throws PolicyModuleFactoryException
  {
    try
    {
      Class cls = classForMessageType(message);
      if (org.mashups4j.governance.policies.PolicyModule.class.isAssignableFrom(cls))
      {
        Object obj = cls.newInstance();
        PolicyModule policyModule = (PolicyModule)obj;
        policyModule.initialize();
        return policyModule;
      }
      else
      {
        throw new PolicyModuleFactoryException("Policy module class is not derived from the PolicyModule class");
      }
    }
    catch (Exception e)
    {
      throw new PolicyModuleFactoryException(e);
    }
  }

  private static Class classForMessageType(Message message)
    throws PolicyModuleFactoryException
  {
    String contentType = message.getContentType();

    // enable policy constraints based on content type and message attributes
    return SimplePolicyModule.class;
  }
}
