package org.mashups4j.kernel;

import java.util.Properties;
import java.io.File;

/**
 * User: jhanson
 * Date: Jul 14, 2008
 * Time: 11:50:34 PM
 */
public interface Kernel
{
  int UNINSTALLED = 1;
  int INSTALLED = 2;
  int RESOLVED = 4;
  int STARTING = 8;
  int STOPPING = 16;
  int ACTIVE = 32;
  
  void initialize()
    throws KernelException;

  void start()
    throws KernelException;

  void stop()
      throws KernelException;

  int getState();

  public void setBundlesLocation(File bundlesLocation);

  public File getBundlesLocation();

  Object installBundle(String bundleLocation)
        throws KernelException;

  void uninstallBundle(String bundleLocation)
          throws KernelException;

  Object[] getInstalledBundles();

  String[] getInstalledServiceNames();

  String[] getInstalledServicePaths();

  Object getServiceByPath(String servicePath);

  Object getServiceByName(String serviceName);

  Object invokeService(Object service, Properties props)
            throws KernelException;
}
