package org.mashups4j.kernel.osgi;

import java.util.EventObject;

/**
 * User: jhanson
 * Date: Jul 14, 2008
 * Time: 8:25:50 PM
 */
public class BundlePollerEvent
  extends EventObject
{
  private String m_bundleLocation = "";

  /**
   * Constructs a prototypical Event.
   *
   * @param source The object on which the Event initially occurred.
   * @param bundleLocation The location of a bundle.
   * @throws IllegalArgumentException if source is null.
   */
  public BundlePollerEvent(Object source, String bundleLocation)
  {
    super(source);

    m_bundleLocation = bundleLocation;
  }

  /**
   * Retrieves the location for the bundle in question
   *
   * @return the location of the bundle
   */
  public String getBundleLocation()
  {
    return m_bundleLocation;
  }
}
