package org.mashups4j.mediation;

import org.mashups4j.mediation.auditing.SimpleAuditModule;
import org.mashups4j.mediation.logging.SimpleLoggingModule;

/**
 * User: jhanson
 * Date: Aug 2, 2008
 * Time: 3:06:49 PM
 */
public class MessageClient
{
  public static final String RDF_CONTENT = "<rdf:RDF\n" +
                                           "  xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n" +
                                           "  xmlns:em=\"http://www.example.org/email#\">\n" +
                                           "\n" +
                                           "<rdf:Description\n" +
                                           "  rdf:about=\"http://www.example.org/contacts/John%20Doe\">\n" +
                                           "  <em:email>jdoe@example.org</em:email>\n" +
                                           "</rdf:Description>\n" +
                                           "\n" +
                                           "<rdf:Description\n" +
                                           "  rdf:about=\"http://www.example.org/contacts/Bill%20Smith\">\n" +
                                           "  <em:email>bsmith@example.org</em:email>\n" +
                                           "</rdf:Description>\n" +
                                           "</rdf:RDF>";

  public static void main(String[] args)
  {
    MessageClient app = new MessageClient();
    app.mediateMessage();
  }

  private void mediateMessage()
  {
    Message message = new SimpleMessage("application/rdf+xml");
    message.setContent(RDF_CONTENT);

    try
    {
      System.setProperty("org.mashups4j.audit.module", SimpleAuditModule.class.getName());
      System.setProperty("org.mashups4j.logging.module", SimpleLoggingModule.class.getName());
      System.setProperty("org.mashups4j.mediator", SimpleMediator.class.getName());
      Mediator mediator = MediatorFactory.newMediator();
      mediator.mediate(message);
      System.out.println("\nMediated message:\n" + message.getContent());
    }
    catch (Throwable t)
    {
      t.printStackTrace();
    }
  }
}
