package org.mashups4j.mediation.auditing;

import org.mashups4j.mediation.Message;

/**
 * User: jhanson
 * Date: Aug 1, 2008
 * Time: 8:34:40 PM
 */
public class AuditModuleFactory
{
  public static AuditModule getAuditModule(Message message)
    throws AuditModuleFactoryException
  {
    String auditModuleClsName = System.getProperty("org.mashups4j.audit.module");
    if (null == auditModuleClsName || auditModuleClsName.length() <= 0)
    {
      throw new AuditModuleFactoryException("AuditModule system property is not set");
    }

    try
    {
      Class cls = Class.forName(auditModuleClsName);
      if (org.mashups4j.mediation.auditing.AuditModule.class.isAssignableFrom(cls))
      {
        Object obj = cls.newInstance();
        AuditModule auditModule = (AuditModule)obj;
        auditModule.initialize();
        return auditModule;
      }
      else
      {
        throw new AuditModuleFactoryException("Audit module system property is not derived from the AuditModule class");
      }
    }
    catch (Exception e)
    {
      throw new AuditModuleFactoryException(e);
    }
  }
}
