package org.mashups4j.monitoring;

/**
 * User: jhanson
 * Date: Aug 3, 2008
 * Time: 7:29:52 PM
 */
public class CmdLineAdminConsole
  implements EventManagerListener
{
  public static void main(String[] args)
  {
    CmdLineAdminConsole app = new CmdLineAdminConsole();
    try
    {
      app.monitorEvents();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void monitorEvents()
    throws EventManagerFactoryException, EventManagerException
  {
    System.setProperty("org.mashups4j.event.manager", SimpleEventManager.class.getName());
    final EventManager evtMgr = EventManagerFactory.newEventManager();
    evtMgr.addEventManagerListener(this);

    Runtime.getRuntime().addShutdownHook(new Thread()
    {
      public void run()
      {
        try
        {
          evtMgr.stop();
        }
        catch (EventManagerException e)
        {
          e.printStackTrace();
        }

        System.out.println("Command-line admin console stopped");
      }
    });

    System.out.println("Command-line admin console started");
    evtMgr.start();
  }

  public void eventOccurred(ManagementEvent evt)
  {
    System.out.println("Encountered management event: timestamp ["
                       + evt.getTimeStamp() + "], type ["
                       + evt.getType() + "], content ["
                       + evt.getContent() + "], source ["
                       + evt.getSource() + "]");
  }
}
