package org.mashups4j.monitoring;

/**
 * User: jhanson
 * Date: Aug 3, 2008
 * Time: 7:32:33 PM
 */
public class EventManagerFactory
{
  public static EventManager newEventManager()
    throws EventManagerFactoryException
  {
    String evtMgrClsName = System.getProperty("org.mashups4j.event.manager");
    if (null == evtMgrClsName || evtMgrClsName.length() <= 0)
    {
      throw new EventManagerFactoryException("EventManager system property is not set");
    }

    try
    {
      Class cls = Class.forName(evtMgrClsName);
      if (org.mashups4j.monitoring.EventManager.class.isAssignableFrom(cls))
      {
        Object obj = cls.newInstance();
        EventManager evtMgr = (EventManager)obj;
        evtMgr.initialize();
        return evtMgr;
      }
      else
      {
        throw new EventManagerFactoryException("EventManager system property is not derived from the EventManager class");
      }
    }
    catch (Exception e)
    {
      throw new EventManagerFactoryException(e);
    }
  }
}
