package org.mashups4j.resources;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;

/**
 * User: jhanson
 * Date: Nov 12, 2008
 * Time: 8:38:03 PM
 */
public interface ResourceCache
{
  void createResource(String resourcePath,
                      Object context,
                      Object data)
    throws ResourceException;

  Resource readResource(String resourcePath,
                        Object context,
                        boolean getCurrentCopy)
    throws ResourceException;

  void updateResource(String resourcePath,
                      Object context,
                      Object data)
    throws ResourceException;

  void deleteResource(String resourcePath,
                      Object context)
    throws ResourceException;

  long getResourceLastModified(String resourcePath,
                               Object context)
    throws ResourceException;
}
