package org.mashups4j.resources;

/**
 * User: jhanson
 * Date: Nov 11, 2008
 * Time: 8:47:05 PM
 */
public class SimpleResource
  implements Resource
{
  private String resourceFileName = "";
  private byte[] resourceBytes = null;

  public SimpleResource(String resourceFileName, byte[] resourceBytes)
  {
    this.resourceFileName = resourceFileName;
    this.resourceBytes = resourceBytes;
  }

  public String getMimeType()
  {
    if (resourceFileName.toLowerCase().endsWith(".txt"))
    {
      return("text/plain");
    }
    else if (resourceFileName.toLowerCase().endsWith(".xml"))
    {
      return("text/xml");
    }
    else if (resourceFileName.toLowerCase().endsWith(".html"))
    {
      return("text/html");
    }
    else if (resourceFileName.toLowerCase().endsWith(".rss"))
    {
      return("application/rss+xml");
    }
    else if (resourceFileName.toLowerCase().endsWith(".rdf"))
    {
      return("application/rdf+xml");
    }
    else if (resourceFileName.toLowerCase().endsWith(".atom"))
    {
      return("application/atom+xml");
    }
    else if (resourceFileName.toLowerCase().endsWith(".xls"))
    {
      return("application/vnd.ms-excel");
    }
    else if (resourceFileName.toLowerCase().endsWith(".doc"))
    {
      return("application/msword");
    }

    return "text/plain";
  }

  public int getContentLength()
  {
    System.out.println(getClass().getName() + ".getContentLength returning: " + resourceBytes.length);
    return resourceBytes.length;
  }

  public byte[] getBytes()
  {
    return resourceBytes;
  }

  public boolean canBeStringified()
  {
    if (resourceFileName.toLowerCase().endsWith(".txt"))
    {
      return true;
    }
    else if (resourceFileName.toLowerCase().endsWith(".xml"))
    {
      return true;
    }
    else if (resourceFileName.toLowerCase().endsWith(".html"))
    {
      return true;
    }
    else if (resourceFileName.toLowerCase().endsWith(".rss"))
    {
      return true;
    }
    else if (resourceFileName.toLowerCase().endsWith(".rdf"))
    {
      return true;
    }
    else if (resourceFileName.toLowerCase().endsWith(".atom"))
    {
      return true;
    }

    return false;
  }

  public String toString()
  {
    return new String(resourceBytes);
  }
}
