package org.mashups4j.services;

import org.mashups4j.web.Model;
import org.mashups4j.kernel.Kernel;

/**
 * User: jhanson
 * Date: Jun 10, 2008
 * Time: 8:16:50 PM
 */
public class ServiceCache
{
  private static ServiceCache instance = null;

  // =====================================================
  // non-public static methods
  // =====================================================

  private static ServiceCache getInstance(Kernel kernel)
  {
    if (null == instance)
    {
      instance = new ServiceCache(kernel);
    }

    return instance;
  }

  // =====================================================
  // public static methods
  // =====================================================

  public static Object get(Kernel kernel, String servicePath)
    throws ServiceException
  {
    return getInstance(kernel).getService(servicePath);
  }

  // =====================================================
  // member fields
  // =====================================================

  private Kernel kernel = null;

  // =====================================================
  // constructors
  // =====================================================

  public ServiceCache(Kernel kernel)
  {
    this.kernel = kernel;
  }

  // =====================================================
  // non-public instance methods
  // =====================================================

  private Object getService(String servicePath)
    throws ServiceException
  {
    if (servicePath == null || servicePath.length() <= 0)
    {
      throw new ServiceException("Service path is empty in "
                                 + getClass().getName()
                                 + ".getService()");
    }

    Object service = kernel.getServiceByPath(servicePath);
    if (null != service)
    {
      return service;
    }
    
    throw new ServiceException("Service [" + servicePath + "] not found in "
                               + getClass().getName()
                               + ".getService()");
  }
}
