package org.mashups4j.services;

import org.mashups4j.web.Model;

import javax.servlet.http.HttpServletRequest;
import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;
import java.util.Properties;
import java.util.Enumeration;

/**
 * User: jhanson
 * Date: Nov 9, 2008
 * Time: 2:31:26 PM
 */
public class ServiceHelper
{
  /**
   *
   * @param service
   * @param request
   * @return
   */
  public static Model dynamicallyInvokeService(Object service, HttpServletRequest request)
  {
    Properties paramProps = new Properties();
    Enumeration enumer = request.getParameterNames();
    while (enumer.hasMoreElements())
    {
      String paramName = (String)enumer.nextElement();
      paramProps.put(paramName, request.getParameter(paramName));
    }

    return dynamicallyInvokeService(service, paramProps);
  }

  public static Model dynamicallyInvokeService(Object service, final Properties props)
  {
    // we are looking for this method: public Object execute(Properties props)

    Method method = null;

    try
    {
      method = service.getClass().getMethod("execute", Properties.class);

      try
      {
        System.out.println("<<< Invoking execute on service object [" + service + "] >>>");
        final Object retObj = method.invoke(service, props);
        Model model = null;
        if (retObj instanceof Model)
        {
          model = (Model)retObj;
        }
        else
        {
          model = new Model()
          {
            public Object contents = retObj;

            public String getMimeType()
            {
              String outputtype = (String)props.get("outputtype");
              if (outputtype != null)
              {
                if (outputtype.equalsIgnoreCase("xml"))
                {
                  return "application/xml";
                }
              }
              
              return "text/plain";
            }

            public int getContentLength()
            {
              return contents.toString().length();
            }

            public boolean canBeStringified()
            {
              return true;
            }

            public byte[] getBytes()
            {
              return contents.toString().getBytes();
            }

            public void setContents(Object contents)
            {
              this.contents = contents;
            }

            public String toString()
            {
              return contents.toString();
            }
          };
        }

        return model;
      }
      catch (IllegalAccessException e)
      {
        e.printStackTrace();
      }
      catch (InvocationTargetException e)
      {
        e.printStackTrace();
      }
    }
    catch (NoSuchMethodException e)
    {
      e.printStackTrace();
    }

    return null;
  }
}
