package org.mashups4j.workflow;

import java.util.*;

/**
 * User: jhanson
 * Date: Sep 7, 2008
 * Time: 11:06:43 PM
 */
public class SimpleContext
  implements WorkflowContext
{
  private String id = "";
  private Properties properties = new Properties();
  private Properties errors = new Properties();

  public SimpleContext(String id)
  {
    this.id = id;
  }

  public String getID()
  {
    return id;
  }

  public void addError(String errorName, Object errorObj)
  {
    errors.put(errorName, errorObj);
  }

  public Iterator getErrorNames()
  {
    return errors.keySet().iterator();
  }

  public Object getError(String errorName)
  {
    return errors.get(errorName);
  }

  public int size()
  {
    return properties.size();
  }

  public boolean isEmpty()
  {
    return properties.isEmpty();
  }

  public boolean containsKey(Object key)
  {
    return properties.containsKey(key);
  }

  public boolean containsValue(Object value)
  {
    return properties.containsValue(value);
  }

  public Object get(Object key)
  {
    return properties.get(key);
  }

  public Object put(Object key, Object value)
  {
    return properties.put(key, value);
  }

  public Object remove(Object key)
  {
    return properties.remove(key);
  }

  public void putAll(Map t)
  {
    properties.putAll(t);
  }

  public void clear()
  {
    properties.clear();
  }

  public Set keySet()
  {
    return properties.keySet();
  }

  public Collection values()
  {
    return properties.values();
  }

  public Set entrySet()
  {
    return properties.entrySet();
  }
}
