package org.mashups4j.workflow;

public class WorkflowFactory
{
  public static Workflow getInstance(String workflowConfigName)
    throws WorkflowFactoryException
  {
    try
    {
      String clsName = System.getProperty("org.mashups4j.workflow");
      if (null == clsName || clsName.length() <= 0)
      {
        clsName = SimpleWorkflow.class.getName();
      }
      
      Class cls = Class.forName(clsName);
      if (org.mashups4j.workflow.Workflow.class.isAssignableFrom(cls))
      {
        Object obj = cls.newInstance();
        Workflow instance = (Workflow)obj;
        instance.initialize(workflowConfigName);
        return instance;
      }
      else
      {
        throw new WorkflowFactoryException(
          "Workflow object is not derived from the Workflow class");
      }
    }
    catch (Exception e)
    {
      throw new WorkflowFactoryException(e);
    }
  }
}
