package org.mashups4j.workflow;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * User: jhanson
 * Date: Sep 7, 2008
 * Time: 10:09:06 PM
 */
public class XMLUtils
{
  public static Node findFirstNamedChild(Node parentNode, String childName)
  {
    NodeList childNodes = parentNode.getChildNodes();

    if (null != childNodes && childNodes.getLength() > 0)
    {
      for (int i = 0; i < childNodes.getLength(); i++)
      {
        Node aNode = childNodes.item(i);
        if (aNode.getNodeName().equalsIgnoreCase(childName))
        {
          return aNode;
        }
      }
    }

    return null;
  }

  public static String loadAttrValue(NamedNodeMap attributes, String attrName)
  {
    Node attrNode = attributes.getNamedItem(attrName);
    if (null == attrNode)
    {
      System.err.println("Found node in without a [" + attrName + "] attribute.");
    }
    else
    {
      String attrValue = attrNode.getNodeValue();
      if (null == attrValue || attrValue.length() <= 0)
      {
        System.err.println("Found node in without a [" + attrName + "] attribute value.");
      }
      else
      {
        return attrValue;
      }
    }

    return null;
  }
}
