<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xmlns:v="urn:schemas-microsoft-com:vml">
<head>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
  <title>Google Maps</title>

  <script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key=ABQIAAAA7kHuyDenRy7D_kXwDkUfhBQCabR54RQscLxLTjQlrb8wKm07EBRSANMlyMuVIxp6jUQazrN52Pzp3w"
    type="text/javascript"></script>

  <script type="text/javascript">
    //<![CDATA[

    if (GBrowserIsCompatible())
    {
      function createMarker(point, html)
      {
        var marker = new GMarker(point);
        GEvent.addListener(marker, "click", function()
        {
          marker.openInfoWindowHtml(html);
        });
        return marker;
      }

      function createMap(latitude, longitude, twitterUser)
      {
        // Display the map, with some controls and set the initial location
        var map = new GMap2(document.getElementById("map"));
        map.addControl(new GLargeMapControl());
        map.addControl(new GMapTypeControl());
        map.setCenter(new GLatLng(latitude, longitude), 8);

        // Set up marker

        var point = new GLatLng(latitude, longitude);
        var marker = createMarker(point, twitterUser)
        map.addOverlay(marker);
      }

      function ajaxPost(apiURL)
      {
        var twitterUser = document.getMapForm.TwitterUser.value;
        var xmlRequest = new XMLHttpRequest();
        xmlRequest.open("POST", apiURL + '?outputtype=xml&twitterUserID=' + twitterUser, false);  // false indicates synchronous call
        xmlRequest.send(twitterUser);
        if (xmlRequest.status == 200)
        {
          if (xmlRequest.responseText)
          {
            //alert("ajaxPost returned [" + xmlRequest.responseText + "]");
            var xmlDoc = xmlRequest.responseXML;

            var latitude = xmlDoc.getElementsByTagName('latitude')[0].firstChild.data;
            var longitude = xmlDoc.getElementsByTagName('longitude')[0].firstChild.data;

            //alert("latitude = " + latitude + ", longitude" + longitude + ", twitterUser = " + twitterUser);

            createMap(latitude, longitude, twitterUser);

            //alert("map created");
          }
        }
        else
        {
          alert("ajaxPost failed with status: " + xmlRequest.status);
        }
      }

      function ajaxGet(apiURL)
      {
        var twitterUser = document.getMapForm.TwitterUser.value;
        var xmlRequest = new XMLHttpRequest();
        xmlRequest.open("GET", apiURL + '?outputtype=xml&twitterUserID=' + twitterUser, false);  // false indicates synchronous call
        xmlRequest.send(twitterUser);
        if (xmlRequest.status == 200)
        {
          if (xmlRequest.responseText)
          {
            //alert("ajaxPost returned [" + xmlRequest.responseText + "]");
            var xmlDoc = xmlRequest.responseXML;

            var latitude = xmlDoc.getElementsByTagName('latitude')[0].firstChild.data;
            var longitude = xmlDoc.getElementsByTagName('longitude')[0].firstChild.data;

            //alert("latitude = " + latitude + ", longitude" + longitude + ", twitterUser = " + twitterUser);

            createMap(latitude, longitude, twitterUser);

            //alert("map created");
          }
        }
        else
        {
          alert("ajaxGet failed with status: " + xmlRequest.status);
        }
      }
    }
    else
    {
      // display a warning if the browser was not compatible
      alert("Sorry, the Google Maps API is not compatible with this browser");
    }

    //]]>
  </script>
</head>

<body onunload="GUnload()">

<p/>

<form method="POST"
      action="javascript:ajaxGet('http://localhost:8080/api/twoogle')"
      name="getMapForm">
  Twitter user name: <input type="text" value="" name="TwitterUser"/><input type="submit" value="Get Map" name="submit"/>
</form>

<p/>

<form method="GET"
      action="http://localhost:8080/data/feeds/rss/zurn.rss"
      name="getResource">
  <input type="submit" value="Get Resource" name="submit"/>
</form>

<p/>

<form method="POST"
      action="http://localhost:8080/data/flatfiles/test.txt?value=This+is+some+more+text"
      name="updateResource">
  <input type="submit" value="Update Resource" name="submit"/>
</form>

<p/>

<div id="map" style="width: 550px; height: 450px"></div>
</body>

</html>
