//===================================================
// initializes the XMLHTTP object
//===================================================
function getHTTPObject()
{
  var xmlhttp = null;
  var success = false;

  // List of MS XMLHTTP versions - newest first
  var MSXML_XMLHTTP_PROGIDS = new Array(
      'MSXML2.XMLHTTP.5.0',
      'MSXML2.XMLHTTP.4.0',
      'MSXML2.XMLHTTP.3.0',
      'MSXML2.XMLHTTP',
      'Microsoft.XMLHTTP'
  );

  for (var i = 0; i < MSXML_XMLHTTP_PROGIDS.length && !success; i++)
  {
    try
    {
       xmlhttp = new ActiveXObject(MSXML_XMLHTTP_PROGIDS[i]);
       success = true;
       return xmlhttp;
    }
    catch (e)
    {
       xmlhttp = false;
    }
  }

  if (!xmlhttp && typeof XMLHttpRequest != 'undefined')
  {
    try
    {
       xmlhttp = new XMLHttpRequest();
    }
    catch (e)
    {
       xmlhttp = false;
    }
  }

  return xmlhttp;
}

//===================================================
// performs a synchronous Ajax request
//===================================================
function ajaxSyncRequest(apiURL, getOrPost, requestData, callbackFunc)
{
  var xmlRequest = getHTTPObject();

  xmlRequest.open(getOrPost, apiURL, false);  // false indicates synchronous call
  xmlRequest.send(requestData);

  if (xmlRequest.status == 200)
  {
    if (callbackFunc)
    {
      if (xmlRequest.responseText)
      {
        callbackFunc(xmlRequest.responseText);
      }
    }
  }
  else
  {
    alert("ajaxSyncRequest failed with status: " + xmlRequest.status);
  }
}
