package org.mashups4j.web;

import junit.framework.Test;
import junit.framework.TestSuite;
import junit.framework.TestCase;

/**
 * ContactsValidator Tester.
 *
 * @author <Authors name>
 * @version 1.0
 * @since <pre>09/22/2008</pre>
 */
public class ContactsValidatorTest
  extends TestCase
{
  public ContactsValidatorTest(String name)
  {
    super(name);
  }

  public void setUp()
    throws Exception
  {
    super.setUp();
  }

  public void tearDown()
    throws Exception
  {
    super.tearDown();
  }

  public void testValidate()
    throws Exception
  {
    String validatorName = ValidatorFactory.CONTACTS_VALIDATOR;
    Validator validator = ValidatorFactory.getValidator(validatorName);

    if (validator.validate(ContactsValidator.CONTACT_NAME, "John 123 Doe"))
    {
      throw new Exception("ContactsValidator should have caught CONTACT_NAME test");
    }
    if (!validator.validate(ContactsValidator.CONTACT_NAME, "John Doe"))
    {
      throw new Exception("ContactsValidator should have allowed CONTACT_NAME test");
    }

    if (validator.validate(ContactsValidator.CONTACT_ADDRESS, "123 Anywhere St+++"))
    {
      throw new Exception("ContactsValidator should have caught CONTACT_ADDRESS test");
    }
    if (!validator.validate(ContactsValidator.CONTACT_ADDRESS, "123 Anywhere St"))
    {
      throw new Exception("ContactsValidator should have allowed CONTACT_ADDRESS test");
    }

    if (validator.validate(ContactsValidator.CONTACT_CITY, "Mytown---"))
    {
      throw new Exception("ContactsValidator should have caught CONTACT_CITY test");
    }
    if (!validator.validate(ContactsValidator.CONTACT_CITY, "Mytown"))
    {
      throw new Exception("ContactsValidator should have allowed CONTACT_CITY test");
    }

    if (validator.validate(ContactsValidator.CONTACT_STATE, "XX"))
    {
      throw new Exception("ContactsValidator should have caught CONTACT_STATE test");
    }
    if (!validator.validate(ContactsValidator.CONTACT_STATE, "NV"))
    {
      throw new Exception("ContactsValidator should have allowed CONTACT_STATE test");
    }

    if (validator.validate(ContactsValidator.CONTACT_ZIP, "12345rr"))
    {
      throw new Exception("ContactsValidator should have caught CONTACT_ZIP test");
    }
    if (!validator.validate(ContactsValidator.CONTACT_ZIP, "12345"))
    {
      throw new Exception("ContactsValidator should have allowed CONTACT_ZIP test");
    }

    if (validator.validate(ContactsValidator.CONTACT_PHONE, "(123)+456-7890"))
    {
      throw new Exception("ContactsValidator should have caught CONTACT_PHONE test");
    }
    if (!validator.validate(ContactsValidator.CONTACT_PHONE, "(123) 456-7890"))
    {
      throw new Exception("ContactsValidator should have allowed CONTACT_PHONE test");
    }

    if (validator.validate(ContactsValidator.CONTACT_EMAIL, "jdoe+rigma.com"))
    {
      throw new Exception("ContactsValidator should have caught CONTACT_EMAIL test");
    }
    if (!validator.validate(ContactsValidator.CONTACT_EMAIL, "jdoe@rigma.com"))
    {
      throw new Exception("ContactsValidator should have allowed CONTACT_EMAIL test");
    }
  }

  public static Test suite()
  {
    return new TestSuite(ContactsValidatorTest.class);
  }
}
