package org.mashups4j.services.twitter;

import org.mashups4j.services.utils.HTTPUtils;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.xml.sax.InputSource;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import java.io.*;
import java.util.Properties;

/**
 * User: jhanson
 * Date: Nov 6, 2008
 * Time: 9:24:05 PM
 *
 * Implementation of a Twitter service;
 * see TwitterService for details of the service.
 */
public class TwitterImpl
  implements TwitterService
{
  private static final String API_URL = "http://twitter.com/users/show/";

  /**
  * Retrieves the location of a given user.
  *
  * @param targetUserID - the ID of the user
  * @throws Exception
  */
  public String getUserLocation(String targetUserID)
    throws Exception
  {
    System.out.println(">>> Inside " + getClass().getName() + ".getUserLocation()");
    
    String response = HTTPUtils.sendHTTPRequest(API_URL + targetUserID + ".xml", null);
    DocumentBuilder docBuilder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
    Document doc = docBuilder.parse(new InputSource(new StringReader(response)));
    if (null != doc)
    {
      NodeList nodeList = doc.getElementsByTagName("location");
      if (null != nodeList && nodeList.getLength() > 0)
      {
        Node locationNode = nodeList.item(0);
        if (null != locationNode)
        {
          return locationNode.getTextContent();
        }
      }
    }

    throw new Exception("Invalid HTTP response content encountered");
  }

  public Object execute(Properties props)
  {
    System.out.println(">>> Inside " + getClass().getName() + ".execute()");
    
    Object targetUserIDObj = props.get("targetUserID");
    String retStr = "";
    try
    {
      retStr = getUserLocation((String)targetUserIDObj);
    }
    catch(Throwable t)
    {
      t.printStackTrace();
    }
    
    return retStr;
  }
}
