package org.mashups4j.services.twoogle;

import org.mashups4j.services.utils.HTTPUtils;
import org.mashups4j.services.twitter.TwitterImpl;
import org.mashups4j.services.google.GoogleMapsImpl;
import org.mashups4j.services.google.LatitudeLongitude;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.xml.sax.InputSource;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import java.io.*;
import java.util.Properties;

/**
 * User: jhanson
 * Date: Nov 6, 2008
 * Time: 9:24:05 PM
 *
 * Implementation of a Twitter/Google hybrid service;
 * see TwoogleService for details of the service.
 */
public class TwoogleImpl
  implements TwoogleService
{
  private static final String API_URL = "http://twitter.com/users/show/";

  /**
  * Retrieves the location of a given user.
  *
  * @param targetUserID - the ID of the user
  * @throws Exception
  */
  public String getMapForTwitterLocation(String twitterUserID)
    throws Exception
  {
    System.out.println(">>> Inside " + getClass().getName() + ".getMapForTwitterLocation()");
    
    TwitterImpl twitter = new TwitterImpl();
    String userLocation = twitter.getUserLocation(twitterUserID);
    
    GoogleMapsImpl googleMaps = new GoogleMapsImpl();
    LatitudeLongitude latLong = new LatitudeLongitude("", "");
    googleMaps.locationToLatLong(userLocation, latLong);
    
    return "<results><latitude>" + latLong.latitude + "</latitude>" +
            "<longitude>" + latLong.longitude + "</longitude></results>";
  }

  public Object execute(Properties props)
  {
    System.out.println(">>> Inside " + getClass().getName() + ".execute()");
    
    String retStr = "";
    
    try
    {
      Object twitterUserIDObj = props.get("twitterUserID");
      retStr = getMapForTwitterLocation((String)twitterUserIDObj);
    }
    catch(Throwable t)
    {
      t.printStackTrace();
    }
    
    return retStr;
  }
}
