package org.mashups4j.services.utils;

import java.net.HttpURLConnection;
import java.net.URL;
import java.io.*;

/**
 * User: jhanson
 * Date: Sep 14, 2008
 * Time: 8:45:05 PM
 */
public class HTTPUtils
{
  public static String encodeBasicAuthenticationString(String username, String password)
  {
    return "Basic " +
           new String(new sun.misc.BASE64Encoder().encode((username + ":" + password).getBytes()));
  }

  public static String sendHTTPRequest(String url, String basicAuthStr)
    throws Exception
  {
    String res = null;

    int responseCode = -1;

    try
    {
      HttpURLConnection con = null;
      InputStream inStream = null;
      OutputStream outputStream = null;

      try
      {
        con = (HttpURLConnection) new URL(url).openConnection();
        con.setDoInput(true);
        if (null != basicAuthStr && basicAuthStr.length() > 0)
        {
          con.addRequestProperty("Authorization", basicAuthStr);
        }
        System.out.println("GET " + url);
        con.setRequestMethod("GET");
        responseCode = con.getResponseCode();
        //System.out.println("Response code: " + String.valueOf(responseCode));
        inStream = con.getInputStream();
        res = parseHTTPResponse(inStream);
        System.out.println("Response: " + res);
      }
      finally
      {
        try
        {
          inStream.close();
        }
        catch (Exception e)
        {
        }

        try
        {
          outputStream.close();
        }
        catch (Exception e)
        {
        }

        try
        {
          con.disconnect();
        }
        catch (Exception e)
        {
        }
      }
    }
    catch (IOException e)
    {
      if (responseCode == 401 || responseCode == 403)
      {
        e.printStackTrace();
        throw new Exception(e.getMessage() + " : " + responseCode);
      }
      throw new Exception(e.getMessage() + " : " + responseCode);
    }

    return res;
  }

  public static String parseHTTPResponse(InputStream inStream)
    throws IOException
  {
    BufferedReader br = null;
    br = new BufferedReader(new InputStreamReader(inStream, "UTF-8"));
    StringBuffer buf = new StringBuffer();
    String line;
    while (null != (line = br.readLine()))
    {
      buf.append(line).append("\n");
    }
    return buf.toString();
  }
}
